<!DOCTYPE html>
<html lang="en">

<head>

    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>contactDetail</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body onload="onPageloading()">
    <div class="container jumbotron">
        <form id="submit">
            <h2 class="text-center" style="padding: 5%;">THÔNG TIN LIÊN HỆ CHI TIẾT</h2>
            <div class="form-group row">
                <label class="col-sm-2 col-form-label">Name</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control" id="input-name">
                </div>
            </div>
            <div class="form-group row">
                <label class="col-sm-2 col-form-label">Email</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control" id="input-email">
                </div>
            </div>
            <div class="form-group row">
                <label class="col-sm-2 col-form-label">Message</label>
                <div class="col-sm-10">
                    <textarea class="form-control" id="input-message"></textarea>
                </div>
            </div>
            <div class="form-group row">
                <label class="col-sm-2 col-form-label">Ngày liên hệ</label>
                <div class="col-sm-10">
                    <input type="text" class="form-control" id="input-date">
                </div>
            </div>
            <div class="row" style="margin-left: 50%;">
                <button onclick="onBtSaveData()" class="btn btn-success">Save data</button>
            </div>
        </form>
    </div>
</body>
<script>
    "use strict";
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "https://62442d9d3da3ac772b0c50eb.mockapi.io/api/v1/";
    const vCONTACT_LIST = "listContact.html"
    const vAPI_URL = gBASE_URL + "/contacts/";
    //đối tượng 
    var gId;
    var gSubmitFormElement = document.getElementById("submit");
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    gSubmitFormElement.addEventListener("submit", function (paramEvent) {
        paramEvent.preventDefault();
    })
    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */

    //hàm tải trang
    function onPageloading() {
        "use strict"
        //Tạo đối tượng 
        var vUrlString = window.location.href;
        console.log(vUrlString);
        var vUrl = new URL(vUrlString);

        gId = vUrl.searchParams.get("id");
        //ghi các biến global tra console
        console.log("id: " + gId);
        //B3: gọi API
        callAPI(gId);
    };

    //hàm xử lý khi click nút save data
    function onBtSaveData() {
        "use strict"
        var vContactObj = {
            name: "",
            email: "",
            message: "",
            createDate: ""
        };
        //B1: thu thập dữ liệu
        thuThapDuLieu(vContactObj);
        //B2: khiểm tra dữ liệu hợp lệ
        var vDuLieuHopLe = validateData(vContactObj);
        if (vContactObj) {
            //B3: gọi API sửa dữ liệu
            callAPIFixedData(vContactObj);
        }

    };

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    // hàm gọi API lấy thông tin contact
    function callAPI(paramId) {
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("GET", vAPI_URL + paramId, true);
        vXmlHttp.send();
        vXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttp.responseText);
                //B4: Xử lý hiển thị
                showDataToForm(vXmlHttp)
            }
        }
    }
    //Hàm xử lý hiển thị lên form
    function showDataToForm(paramXMLHttp) {
        var vObj = JSON.parse(paramXMLHttp.responseText);

        var vName = document.getElementById("input-name");
        var vEmail = document.getElementById("input-email");
        var vMessage = document.getElementById("input-message");
        var vDate = document.getElementById("input-date");

        vName.value = vObj.name;
        vEmail.value = vObj.email;
        vMessage.value = vObj.message;
        vDate.value = vObj.createDate;
    }

    //hàm thu thập dữ liệu
    function thuThapDuLieu(paramContactObj) {
        var vName = document.getElementById("input-name");
        var vEmail = document.getElementById("input-email");
        var vMessage = document.getElementById("input-message");
        var vDate = document.getElementById("input-date");

        paramContactObj.name = vName.value.trim();
        paramContactObj.email = vEmail.value.trim();
        paramContactObj.message = vMessage.value;
        paramContactObj.createDate = vDate.value;
    }

    //hàm khiểm tra dữ liệu 
    function validateData(paramContactObj) {
        if (paramContactObj.name === "") {
            alert("Name phải được nhập");
            return false
        }
        if (paramContactObj.email === "") {
            alert("Email phải được nhập");
            return false
        }
        if (validateEmail(paramContactObj.email) != true) {
            alert("Email nhập vào phải đúng định dạng");
            return false;
        }
        if (paramContactObj.message === "") {
            alert("Mesage phải được nhập");
            return false
        }
        if (paramContactObj.message.length < 20) {
            alert("Mesage phải trên 20 ký tự");
            return false
        }
        if (paramContactObj.createDate === "") {
            alert("Vui lòng cập nhật ngày tháng");
            return false;
        }
        return true;

    }
    //hàm kiểm tra Email
    function validateEmail(paramEmails) {
        var isValid = false;
        var regex = /^([a-zA-Z0-9_\.\-])+\@(([a-zA-Z0-9\-])+\.)+([a-zA-Z0-9]{2,4})+$/;
        if (regex.test(paramEmails)) {
            isValid = true;
        }
        return isValid;
    }

    //hàm gọi api
    function callAPIFixedData(paramContactObj) {
        var vXmlHttp = new XMLHttpRequest();
        vXmlHttp.open("PUT", vAPI_URL + gId, true);
        vXmlHttp.setRequestHeader("Content-Type", "application/json");
        vXmlHttp.send(JSON.stringify(paramContactObj));

        vXmlHttp.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                console.log(vXmlHttp.responseText);
                //B4: xử lý hiển thị
                hienThiThongBao(vXmlHttp);
            }
        }
    }

    // hàm thông báo thông tin
    function hienThiThongBao(paramXmlhttp) {
        var vContactObj = paramXmlhttp.responseText
        console.log(vContactObj);

        if(vContactObj.value != ""){
            alert("Sửa thông tin contact thành công");
        }
        window.location.href = vCONTACT_LIST;
    }


</script>

</html>